#ifndef EFRL_H
#define EFRL_H

#ifndef MD_METHOD_H
#include "MD_method.h"
#endif

#ifndef MD_H
#include "MD.h"
#endif

namespace MM
{

// Omelyan I.P., Mryglod I.M., Folk R.
// Optimized Forest-Ruth- and Suzuki-like algorithms for integration
// of motion in many-body systems.
// Computer Phys. Comm. 2002. V.146. No2. pp.188-202

class EFRL : public MD_method
{
public:
    //explicit EFRL (MD_subject & subject) : MD_method (subject) { }

protected:
    virtual double xi    () const =0;
    virtual double lambda() const =0;
    virtual double chi   () const =0;
};

}//MM

#endif //EFRL_H
